//
//  MenuView.m
//  DropDownMenuTest
//
//  Created by lucky on 16/5/31.
//  Copyright © 2016年 Lukcy. All rights reserved.
//

#import "MenuView.h"

@interface MenuView ()<UITableViewDelegate,UITableViewDataSource,UIGestureRecognizerDelegate>

@property (nonatomic,strong) UITableView *firstTabView;
@property (nonatomic,strong) UITableView *secondTabview;
@property (nonatomic,strong) UIView *darkBgView;
@property (nonatomic,strong) NSArray *selectArray;
@property (nonatomic,assign) NSInteger firstIndex;
@property (nonatomic,assign) NSInteger secondIndex;
@property (nonatomic,strong) NSArray *firstArray;
@property (nonatomic,strong) NSMutableArray *secondArray;
@property (nonatomic,assign) NSInteger type;
@end
@implementation MenuView

/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect {
    // Drawing code
}
*/
- (instancetype)initWithFrame:(CGRect)frame contentArray:(NSArray *)contentArr type: (NSInteger)type{
    
    if (self = [super initWithFrame:frame]) {
        _type = type;
        _firstArray = contentArr;
        [self initSetting];
    }
    return self;
}
- (void)initSetting{
    
    _secondArray = [NSMutableArray array];
    _selectArray = [NSArray array];
    _firstIndex = -1;
    _secondIndex = -1;
    if (_type == 0) {
        for (NSDictionary *dic in _firstArray) {
            [_secondArray addObject:dic[@"area"]];
        }
    }
    self.userInteractionEnabled = YES;
    [self setBaseUI];
    [self.firstTabView registerClass:[UITableViewCell class] forCellReuseIdentifier:@"cellId"];
    [self.secondTabview registerClass:[UITableViewCell class] forCellReuseIdentifier:@"secondCellId"];
}
- (UITableView *)firstTabView{
    
    if (!_firstTabView) {
        _firstTabView = [[UITableView alloc] initWithFrame:CGRectMake(0, 0,_type == 0 ?SCREEN_WIDTH/3 : SCREEN_WIDTH, 210) style:UITableViewStylePlain];
        _firstTabView.delegate = self;
        _firstTabView.dataSource = self;
        _firstTabView.showsVerticalScrollIndicator = NO;
        _firstTabView.layer.borderColor = [UIColor blackColor].CGColor;
        _firstTabView.layer.borderWidth = .5;
        _firstTabView.tag = 1000;
        if ([_firstTabView respondsToSelector:@selector(setSeparatorInset:)]){
            [_firstTabView setSeparatorInset:UIEdgeInsetsMake(0, -10, 0, 0)];
        }
        
        if ([_firstTabView respondsToSelector:@selector(setLayoutMargins:)]){
            [_firstTabView setLayoutMargins:UIEdgeInsetsMake(0, -10, 0, 0)];
        }
    }
    return _firstTabView;
}
- (UITableView *)secondTabview{
    
    if (!_secondTabview) {
        _secondTabview = [[UITableView alloc] initWithFrame:CGRectMake(SCREEN_WIDTH/3, 0, SCREEN_WIDTH/3*2, 210) style:UITableViewStylePlain];
        _secondTabview.delegate = self;
        _secondTabview.dataSource = self;
        _secondTabview.tag = 2000;
        _secondTabview.separatorStyle = UITableViewCellSeparatorStyleNone;
        if ([_secondTabview respondsToSelector:@selector(setSeparatorInset:)]){
            [_secondTabview setSeparatorInset:UIEdgeInsetsMake(0, -10, 0, 0)];
        }
        
        if ([_secondTabview respondsToSelector:@selector(setLayoutMargins:)]){
            [_secondTabview setLayoutMargins:UIEdgeInsetsMake(0, -10, 0, 0)];
        }
    }
    return _secondTabview;
}

- (void)setBaseUI{
    
    _darkBgView = [[UIView alloc] initWithFrame:CGRectMake(0, CGRectGetMaxY(self.firstTabView.frame), SCREEN_WIDTH, self.frame.size.height-CGRectGetMaxY(self.firstTabView.frame))];
    _darkBgView.userInteractionEnabled = YES;
    _darkBgView.backgroundColor = [UIColor colorWithWhite:.7 alpha:.3];
    [self addSubview:_darkBgView];
    
    UITapGestureRecognizer *tap = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(tapAction)];
    [_darkBgView addGestureRecognizer:tap];
    [self addSubview:self.firstTabView];
}
- (void)tapAction{
    
    _block(NO,nil);
}
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{
    
    if (tableView.tag == 1000) {
        return _firstArray.count;
    }else{
        
        return _selectArray.count;
    }
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath{
    
    if (tableView.tag == 1000) {
        UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"cellId" forIndexPath:indexPath];
        if (_type == 0) {
            cell.textLabel.text = [NSString stringWithFormat:@"%@",_firstArray[indexPath.row][@"name"]];
        }else{
            
            cell.textLabel.text = [NSString stringWithFormat:@"%@",_firstArray[indexPath.row]];
        }
        
        if (_firstIndex == indexPath.row) {
            [cell.textLabel setTextColor:[UIColor orangeColor]];
        }else{
            [cell.textLabel setTextColor:[UIColor blackColor]];
        }
        return cell;
        
    }else{
        
        UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"secondCellId" forIndexPath:indexPath];
        if (_selectArray.count == 0) {
            cell.textLabel.text = @"全部";
        }else{
            cell.textLabel.text = [NSString stringWithFormat:@"%@",_selectArray[indexPath.row][@"name"]];
        }
        if (_secondIndex == indexPath.row) {
            [cell.textLabel setTextColor:[UIColor orangeColor]];
        }else{
            [cell.textLabel setTextColor:[UIColor blackColor]];
        }
        cell.selectionStyle = UITableViewCellSelectionStyleNone;
        return cell;
    }
    
}
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath{
    
    if (_type == 0) {
        if (tableView.tag == 1000) {
            _selectArray = _secondArray[indexPath.row];
            [UIView animateWithDuration:0.3 animations:^{
                if (indexPath.row == 0) {
                    _block(NO,nil);
                }else{
                    [self addSubview:self.secondTabview];
                    
                }
                _firstIndex = indexPath.row;
                [_firstTabView reloadData];
                [_secondTabview reloadData];
            }];
            
        }else{
            
            NSString *name = [NSString stringWithFormat:@"%@",_selectArray[indexPath.row][@"name"]];
            if ([name isEqualToString:@"全部"]) {
                NSString *nameStr = [NSString stringWithFormat:@"%@",_firstArray[_firstIndex][@"name"]];
                _block(NO,nameStr);
            }else{
                _block(NO,name);
                
            }
            _secondIndex = indexPath.row;
            [_secondTabview reloadData];
            
        }
    }else{
        if (tableView.tag == 1000) {
            _firstIndex = indexPath.row;
            _block(NO,_firstArray[indexPath.row]);
        }
        
    }
    
}
@end
